DEFINE CLS, @ROM_CALL(CLEARLCD)

@ld A, $04
@out (5), A

single GetPixel(REG B, REG C)
{
ASM
{
                     ROM_CALL(FIND_PIXEL)  
                     ld de,$FC00
                     add hl,de
                     and (hl)              ; Zero flag set if no pixel
                     jr nz, hnopixel
                     XOR A
                     ld (TEMPM), A
                     jr halldone
                     hnopixel:
                     ld A, 1
                     ld (TEMPM), A
                     halldone:
}
return(TEMPM)
}

void PutSprite(REG B, REG C, REG HL)
{
ASM
{
           ld de, (PROGRAM_ADDR)
           add hl, de   
                     push bc
                     push de
                     ld a,63
                     sub c
                     ld c,a
                     push hl
                     push hl
                     ROM_CALL(FIND_PIXEL)
                     ld de,$FC00
                     add hl,de
                     ex de,hl
                     pop hl
                     ld b,(hl)
                     inc hl
                     ld c,(hl)
                     inc hl
                     push hl
                     pop ix
                     ex de,hl
                    PS_NewRow:
                     push bc
                     ld d,(ix)
                     inc ix
                     push af
                     push hl
                    PS_NewCol:
                     rl d
                     ld e,a
                     jr nc,PS_NoPixel
                     or (hl)
                     jr PS_NextPixel
                    PS_NoPixel:
                     cpl
                     and (hl) 
                    PS_NextPixel:
                     ld (hl),a
                     ld a,e
                     rrca
                     jr nc,PS_SameByte
                     inc hl
                    PS_SameByte:
                     djnz PS_NewCol
                     pop hl
                     pop af
                     ld de,16
                     add hl,de
                     pop bc
                     dec c
                     jr nz,PS_NewRow
                     pop hl
                     pop de
                     pop bc
}
}
void DelSprite(REG B, REG C)
{
SPRITE(DSBlank)
{
00000000
00000000
00000000
00000000
00000000
00000000
00000000
00000000
}
@ld HL, (DSBlank)
@ld A, B
@ld (ASCII), A
@ld A, C
@ld (ASCII2), A
PutSprite(ASCII, ASCII2, DSBlank)
}

void circle(REG D, REG E, REG B)
{
ASM
{
Circle:                         
        ld      H,0
        ld      L,B
        rlc     B
        ld      A,$03
        sub     B
        push    AF
Loop:
        ld      A,D             ;Point #1
        add     A,H
        ld      B,A
        ld      A,E
        add     A,L
        ld      C,A
        CALL_(PointOn)
        
        ld      A,E             ;Point #2
        sub     L
        ld      C,A
        CALL_(PointOn)
        
        ld      A,D             ;Point #4
        sub     H
        ld      B,A
        CALL_(PointOn)
        
        ld      A,E             ;Point #3
        add     A,L
        ld      C,A
        CALL_(PointOn)
        
        ld      A,D             ;Point #5
        add     A,L
        ld      B,A
        ld      A,E
        add     A,H
        ld      C,A
        CALL_(PointOn)
        
        ld      A,E             ;Point #6
        sub     H
        ld      C,A
        CALL_(PointOn)
        
        ld      A,D             ;Point #8
        sub     L
        ld      B,A
        CALL_(PointOn)
        
        ld      A,E             ;Point #7
        add     A,H
        ld      C,A
        CALL_(PointOn)
        
        ld      A,H             ;is the circle finished ?
        sub     L
        jr      NC,EndCircle     ;yes
        pop     AF
        ld      B,A
        ld      A,H
        bit     7,B
        jr      Z,Pos
Neg1:                            ;case d<0
        rla
        rla
        add     A,B
        add     A,$06
        push    AF
        jr      EndC
Pos:                            ;case d>=0
        sub     L
        rla
        rla
        add     A,B
        add     A,$0A
        push    AF
        dec     L
EndC:                           ;one loop has been performed
        inc     H
        jr      Loop            
EndCircle:
        pop     AF              ;MUST NOT BE REMOVED
}
}

void line(reg E, reg D, reg L, reg H)
{
single way
ASM
{
        ld      A,D
        sub     H
        jr      NC,DXpositive    
DXNegative:
        neg
DXPositive:
        ld      B,A              
        ld      A,E
        sub     L
        jr      NC,DYpositive    ;delta_y > 0
DYNegative:
        neg
DYPositive:                
        sub     B               ;|delta_y|
        push    AF
        jr      C,DeltaX        ;|delta_x| > |delta_y|
DeltaY:
        ld      A,H             ;if |delta_x| < |delta_y| then
        ld      H,L             ;then values x and y are swapped
        ld      L,A             ;so the loop will always be performed on the
        ld      A,D             ;x value. A flag must be set to 
        ld      D,E             ;remind that data must be drawn (y,x) 
        ld      E,A             ;instead of (x,y)

        ;ld      A,$01           
        ;ld      (Flag),A        ;the Flag !!!
DeltaX:
        ld      A,D
        sub     H
        jr      NC,TestDY        ;x1 < x2 
TestDX:
        ex      DE,HL
TestDY:
        ld      A,E
        sub     L
        ld      A,$01
        jr      NC,StoreA
        neg                     ;y1 > y2 : in case2 the 'y' variable
StoreA:
        ld      (Way),A
InitLine:       
        ld      B,H
        ld      C,L
        ld      A,E
        sub     L
        jr      NC,EndInit
        ld      A,L
        ld      L,E
        ld      E,A
EndInit:
        ld      A,E      
        sub     L
        rla
        ld      L,A             ;value to add in case1 (d < 0)
        add     A,H
        sub     D
        ld      E,A             ;'d' variable is initialised
        add     A,H
        sub     D
        ld      H,A             ;value to add in case2 (d >= 0)
Loop2:
        ld      A,B
        sub     D
        jr      NC,EndLine       ;the line is completely drawn.
        pop     AF
        ;ld      A,(Flag)
        bit     7,A
        push    AF
        push    AF
        push    BC
        jr      Z,DrawPoint
        ld      A,B
        ld      B,C
        ld      C,A
DrawPoint:     
        CALL_(PointOn)
        pop     BC
        pop     AF
TestD:
        bit     7,E
        jr      NZ,Case1
Case2:                          ;d >= 0 
        ld      A,E
        add     A,H
        ld      E,A
        ld      A,(Way)
        add     A,C
        ld      C,A
        jr      EndLoop
Case1:                          ;d < 0
        ld      A,E
        add     A,L
        ld      E,A
EndLoop:
        inc     B
        jr      Loop2
EndLine:
        pop     AF              ;MUST NOT BE REMOVED
}
}  

void PutPixel(REG B, REG C)
{
PointOn:
ASM
{
        push    DE             
        push    HL             
        ROM_CALL(FIND_PIXEL)
        ld      DE,$FC00
        add     HL,DE
        or      (HL)
        ld      (HL),A
        pop     HL              
        pop     DE             
        ret             
}
}

void Delpixel(REG B, REG C)                     
{
ASM
{
                     ROM_CALL(FIND_PIXEL)
                     ld de,$FC00
                     add hl,de
                     cpl
                     and (hl)
                     ld (hl),a
}
}
                    
void ChangePixel(REG B, REG C)                     
{
ASM
{
                     ROM_CALL(FIND_PIXEL)
                     ld de,$FC00
                     add hl,de
                     xor (hl)
                     ld (hl),a
}
}
PutPixel(0,0)


